import java.awt.*;
import java.awt.geom.Point2D;
import java.awt.image.BufferedImage;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

public class Reflections extends JComponent {
    private static final long serialVersionUID = 1L;

    private JTextField textfield;

    public Reflections() {
        this.setPreferredSize(new Dimension(800, 600));

        textfield = new JTextField(20);
        textfield.setFont(new Font("Comic Sans MS", Font.PLAIN, 36));
        textfield.setLocation(40, 40);
        textfield.setSize(textfield.getPreferredSize());
        add(textfield);
        
        // make sure we update the reflection every time the textfield changes
        textfield.getDocument().addDocumentListener(new DocumentListener() {
            public void insertUpdate(DocumentEvent e) {
                Reflections.this.repaint();
            }
            public void removeUpdate(DocumentEvent e) {
                Reflections.this.repaint();
            }
            public void changedUpdate(DocumentEvent e) {
                Reflections.this.repaint();
            }
        });
        
    }

    @Override
    protected void paintComponent(Graphics g) {
        Graphics2D g2d = (Graphics2D)g;
        
        // First make an offscreen buffer for rendering the reflection.
        int width = textfield.getWidth();
        int height = textfield.getHeight();
        Image buffer = new BufferedImage(width, height, 
                                         BufferedImage.TYPE_4BYTE_ABGR_PRE);
        Graphics2D gBuffer = (Graphics2D)buffer.getGraphics();
        
        // Fill it with blue just so we can see it for now.
        // (This is only for debugging, subsequent drawing will replace it.)
        gBuffer.setColor(Color.blue);
        gBuffer.fillRect(0, 0, width, height);
        
        // Draw the textfield in the buffer
        //
        // YOUR CODE HERE
        //
        
        // Add a dimming gradient
        //
        // YOUR CODE HERE
        //
        
        // Finally draw the reflection on the screen
        int x = textfield.getX();
        int y = textfield.getY() + textfield.getHeight() + 5; // 5 pixel margin between
        g2d.drawImage(buffer, x, y, null);
    }

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                JFrame frame = new JFrame("Reflections");
                frame.add(new Reflections());
                frame.pack();
                frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                frame.setVisible(true);
            }
        });
    }

}
