import java.awt.*;
import javax.swing.*;

public class TiltingGraphics extends JComponent {
    private static final long serialVersionUID = 1L;

    /**
     * Constructs the component which we'll use like a canvas for our own custom
     * drawing.
     * 
     * @throws HeadlessException
     */
    public TiltingGraphics() throws HeadlessException {
        this.setPreferredSize(new Dimension(800, 600));
    }

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                JFrame frame = new JFrame("TiltingGraphics");
                frame.add(new TiltingGraphics());
                frame.pack();
                frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                frame.setVisible(true);
            }
        });
    }
    
    @Override
    protected void paintComponent(Graphics g) {
        // Set up rendering hints.
        {
            ((Graphics2D) g).setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                    RenderingHints.VALUE_ANTIALIAS_ON);
            ((Graphics2D) g).setRenderingHint(
                    RenderingHints.KEY_TEXT_ANTIALIASING,
                    RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
        }

        // Draw the origins and the scaffolding lines.
        {
            g.setColor(new Color(196, 196, 196));

            g.drawLine(-100, 0, 100, 0);
            g.drawLine(0, -100, 0, 100);

            g.drawRect(100, 50, 400, 50);

            g.drawLine(250, 100, 650, 100);
            g.drawLine(250, 100, 650, 500);
            g.drawLine(650, 100, 650, 500);
        }

        // Draw the horizontal text
        {
            Graphics2D g2d = (Graphics2D) g.create();
            g2d.setComposite(AlphaComposite.getInstance(
                    AlphaComposite.SRC_OVER, 0.5f));

            //
            // YOUR CODE HERE
            //

            paintText(g2d, Color.BLUE);
        }

        // Draw the slanted text
        {
            Graphics2D g2d = (Graphics2D) g.create();
            g2d.setComposite(AlphaComposite.getInstance(
                    AlphaComposite.SRC_OVER, 0.5f));

            //
            // YOUR CODE HERE
            //

            paintText(g2d, Color.RED);
        }
    }

    /**
     * Draws the string "graphics" at (0,0) in the coordinate system of g2d. Do
     * not change this method.
     * 
     * @param g2d
     */
    protected void paintText(Graphics2D g2d, Color color) {
        g2d.setFont(new Font("Helvetica", Font.ITALIC, 10));
        g2d.setColor(color);
        g2d.drawString("graphics", 0, 0);
    }


}
